# This file is based on the Xilinx documentation
# it automatically compiles the fpgadbg_s3sb core
#
# open the project and set project-level properties
project new fpgadbg_s3sb.ise
project set family Spartan3
project set device xc3s200
project set package ft256
project set speed -4
# add all the source HDLs and ucf
xfile add ../../s3sb/fpgadbg_s3sb.vhd
xfile add ../../fpgadbg_core/fpgadbg.vhd
xfile add ../../fpgadbg_core/fpgadbg_uart.vhd
xfile add ../../fpgadbg_core/fpgadbgmem.vhd
xfile add ../../fpgadbg_core/smalluart.vhd
xfile add ../../s3sb/s3sb.ucf
# get top
set top [project get top]
# get project properties available
set props2 [project properties]
# inspect the current value for the following batch application options
set map_guide_mode [project get "MAP Guide Mode"]
puts "MAP Guide Mode = $map_guide_mode"
set par_guide_mode [project get "PAR Guide Mode"]
puts "PAR Guide Mode = $par_guide_mode"
project set "Optimization Goal" Speed
project set "Use LOC Constraints" TRUE
project set "Allow Unmatched LOC Constraints" TRUE
project set "Perform Timing-Driven Packing and Placement" TRUE
project set "Place & Route Effort Level (Overall)" High
project set "Other Place & Route Command Line Options" "-intstyle xflow"
project set "Report Type" "Verbose Report"
project set "Unused IOB Pins" Float
project set "Create Bit File" TRUE
# run the entire xst-to-trce flow
process run "Generate Programming File"
# close project
project close
