#!/usr/bin/python
# Copyright (C) 10.07.2006 Wojciech M. Zabolotny (wzab@ise.pw.edu.pl)
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

import fpgadbg_conv
import os
import serial
import sys
import time

print "Reset the Spartan 3 Starter Board, then press enter"
tmp=sys.stdin.readline()
# You may need to modify the device name in the line below!
# For me it was /dev/ttyUSB0 for you it may be /dev/ttyS0
# or something different
rs=serial.Serial("/dev/ttyUSB0",115200,timeout=30)
# Initialize the conversion
posttrig=900
c1=chr(posttrig & 63)
c2=chr(64 | ((posttrig >> 6) & 63))
c3=chr(128 | ((posttrig >> 12) & 63))
print "Press the button2 to start the timer"
rs.flushInput()
time.sleep(1)
rs.flushInput()
rs.write(c1+c2+c3)
# Now receive the data
# long timeout for the first character (30 secs.)
data=rs.read(1)
if data=="":
    print "No trigger after 30 seconds"
    sys.exit(1)
rs.setTimeout(1) # short timeout for next characters
data=data+rs.read(1000000) #The number should be just "big enough"
# Convert character data into integers
data=[ord(i) for i in data]
assgn=((32,21,"frqdiv2"),
       (20,0,"frqdiv"))
# Create the data converter, and create the LXT file
cnv=fpgadbg_conv.fpgadbg_conv(assgn,8,125,-10,"test.lxt")
cnv.conv(data)
# Display the waveforms if gtkwave is available
os.system("gtkwave test.lxt test.sav")
